chiark / gitweb /
Great reorganization.
[profile] / setup
1 #! /bin/bash
2
3 set -e
4
5 ###--------------------------------------------------------------------------
6 ### Basic setup.
7
8 umask 002
9
10 sub=
11 mkdir -p $HOME$sub
12
13 : ${REPO=http://ftp.distorted.org.uk/ftp/pub/mdw/profile}
14
15 export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
17 ###--------------------------------------------------------------------------
18 ### Sort out command line.
19
20 xstuff= false=
21 while [ $# -gt 0 ]; do
22   case "$1" in
23     -x) xstuff=t;;
24     -n) false=false;;
25     --) shift; break;;
26     -*) echo >&2 "$0: bad option"; exit 1;;
27     *) break;;
28   esac
29   shift
30 done
31
32 ###--------------------------------------------------------------------------
33 ### Environment autoconfiguration.
34
35 ## Find out where I am
36 here=$(pwd)
37
38 ## Suss out how to print things
39 out=$(echo -n "foo"; echo "bar")
40 if [ "$out" = "foobar" ]; then
41   echon="echo -n"
42   echoc=""
43 else
44   echon="echo"
45   echoc='\c'
46 fi
47
48 ## Find out how to fetch things over the net
49 $echon "Finding URL fetcher:$echoc"
50 if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51   GETURL="curl -fs -o"
52   echo " curl."
53 elif wget >/dev/null 2>&1 --version; then
54   GETURL="wget -q -O"
55   echo " wget."
56 else
57   echo " failed!"
58   echo >&2 "$0: failed to find URL fetcher"
59   exit 1
60 fi
61
62 ###--------------------------------------------------------------------------
63 ### Create the necessary directories.
64
65 echo "Creating directories..."
66 for i in bin lib/emacs src; do
67   $echon "  $i:$echoc"
68   if [ -d $HOME$sub/$i ]; then
69     echo " already exists."
70   else
71     mkdir -p $HOME$sub/$i
72     echo " done."
73   fi
74 done
75 echo "  all done."
76
77 ###--------------------------------------------------------------------------
78 ### Install some more complicated programs.
79
80 echo "Installing packages..."
81 systems="
82   mlib:crc-mktab
83   checkpath:tmpdir
84 "
85 [ "$xstuff" ] && systems="$systems
86   xtoys:xatom
87 "
88 for system in $systems; do
89   set -- $(echo $system | tr : ' ')
90   sys=$1 prog=$2
91   $echon "  $sys:$echoc"
92   if $false $prog >/dev/null 2>&1 --version; then
93     echo " already installed."
94   else
95     ( set -e
96       $echon " downloading$echoc"
97       cd $HOME$sub/src
98       rm -rf $sys.tar.gz $sys-$ver
99       $GETURL $sys.tar.gz $REPO/$sys.tar.gz
100       $echon " unpacking$echoc"
101       dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102       gzip -cd $sys.tar.gz | tar xf -
103       $echon " configuring$echoc"
104       cd $dir
105       mkdir build
106       cd build
107       ../configure --prefix=$HOME$sub >>buildlog 2>&1
108       $echon " building$echoc"
109       make >>buildlog 2>&1
110       $echon " installing$echoc"
111       make install >>buildlog 2>&1
112       echo " done."
113     )
114   fi
115 done
116 echo "  all done."
117
118 ###--------------------------------------------------------------------------
119 ### Install global configuration.
120
121 echo -n "Installing dotfile configuration:"
122 if [ -f $HOME$sub/.mdw.conf ]; then
123   echo " already installed."
124 else
125   cp mdw.conf $HOME$sub/.mdw.conf
126   echo " done."
127 fi
128
129 ## Symlink the various dotfiles into place
130 dotfiles="
131   bash_profile bash_logout bashrc inputrc bash_completion
132   emacs emacs-calc vm gnus.el
133   vimrc mg zile
134   mailrc signature
135   cgrc tigrc
136   gdbinit
137   guile
138   toprc
139   aspell.conf
140   lisp-init.lisp:.cmucl-init.lisp
141     lisp-init.lisp:.sbclrc
142     lisp-init.lisp:.clisprc.lisp
143     lisp-init.lisp:.eclrc
144   swank.lisp
145   dircolors colordiffrc screenrc cvsrc indent.pro"
146 [ "$xstuff" ] && dotfiles="$dotfiles
147   xinitrc xsession Xdefaults vncrc vncsession
148   fonts.conf
149   putty-defaults:.putty/sessions/Default%20Settings
150   eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
151   e-keybindings.cfg:.enlightenment/keybindings.cfg
152   evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
153   e16-bindings:.e16/bindings.cfg"
154 echo "Installing dotfiles..."
155 for d in $dotfiles; do
156   target=.$d
157   case $d in
158     *:*) target=${d#*:} d=${d%%:*};;
159   esac
160   ft=$HOME$sub/$target
161   dir=${ft%/*}
162   mkdir -p $dir
163   ln -s $here/dot/$d $ft.new
164   mv $ft.new $ft
165   echo "  $target"
166 done
167 echo "  all done."
168
169 ## Symlink backgrounds.
170 backgrounds="jue-peek.jpg medusa.jpg rayne.jpg"
171 if [ "$xstuff" ]; then
172   echo "Installing backgrounds..."
173   for b in $backgrounds; do
174     for e in enlightenment e16; do
175       dir=$HOME$sub/.$e/backgrounds
176       t=$dir/$b
177       mkdir -p $dir
178       ln -s $here/bg/$b $t.new
179       mv $t.new $t
180     done
181     echo "  $b"
182   done
183   echo "        all done."
184 fi
185
186 ###--------------------------------------------------------------------------
187 ### Process the Git configuration.
188
189 echo -n "Installing Git configuration:"
190 sed "
191 1i\
192 ### generated by $here/setup; do not edit!\
193
194 /@releasekey@/ s::$(bin/mdw-conf release-key 481334C2):g
195 /@gitignore@/ s::$(bin/mdw-conf gitignore $here/git/gitignore):g
196 " git/gitconfig >$HOME/.gitconfig.new
197 mv $HOME/.gitconfig.new $HOME/.gitconfig
198 echo " done."
199
200 ###--------------------------------------------------------------------------
201 ### Install useful scripts included in this package.
202
203 scripts="
204   mdw-editor
205   mdw-pager
206   mdw-conf
207   mdw-build
208   movemail-hack
209   emerge-hack
210   lesspipe.sh
211   start-ssh-agent
212   svnwrap
213   hyperspec"
214 [ "$xstuff" ] && scripts="$scripts
215   xinitcmd
216   un-backslashify-selection
217   xshutdown"
218 echo "Installing scripts..."
219 mkdir -p $HOME$sub/bin
220 for s in $scripts; do
221   ft=$HOME$sub/bin/$s
222   ln -s $here/bin/$s $ft.new
223   mv $ft.new $ft
224   echo "  $s"
225 done
226 echo "  all done."
227
228 ###--------------------------------------------------------------------------
229 ### Set up the Emacs config.
230
231 $echon "Finding a suitable emacs:$echoc"
232 emacs=no
233 for i in emacs22 emacs21 emacs; do
234   if type -p >/dev/null $i; then
235     emacs=$i
236     break
237   fi
238 done
239 if [ $emacs = no ]; then
240   echo " failed."
241   emacs=:
242 else
243   echo " $emacs."
244 fi
245
246 echo "Installing Emacs packages..."
247 emacspkg="
248   make-regexp
249   ew-hols
250   mdw-gnus-patch
251   git git-blame vc-git stgit
252   quilt"
253 for elib in $emacspkg; do
254   $echon "  $elib:$echoc"
255   if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
256        (progn
257          (setq load-path (nconc load-path (list "~/lib/emacs")))
258          (kill-emacs (condition-case nil
259                          (progn (load-library "'"$elib"'") 0)
260                        (error 1))))'; then
261     echo " already installed."
262   else
263     if [ -f el/$elib.el ]; then
264       cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
265     else
266       $echon " downloading$echoc"
267       $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
268     fi
269     $echon " compiling$echoc"
270     (cd $HOME$sub/lib/emacs;
271       $emacs >/dev/null 2>&1 --no-site-file --batch \
272         --eval '(byte-compile-file "'"$elib.el"'")')
273     echo " done."
274   fi
275 done
276 echo "  all done."
277
278 $echon "Setting up Emacs configuration:$echoc"
279 $echon " linking$echoc"
280 for f in dot-emacs.el Makefile; do
281   set -- $(echo $link | tr : ' ')
282   ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
283   mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
284 done
285 $echon " compiling$echoc"
286 make >/dev/null 2>&1 -C $HOME$sub/lib/emacs EMACS=$emacs
287 echo " done."
288
289 ###----- That's all, folks --------------------------------------------------